<?php


namespace App\Models;

use App\Entities\Setor\Setor;
use App\Services\SetorService;
use App\Services\JWTService;
use App\Services\PessoaService;
use App\Services\Service;
use App\Utils\DateUtils;
use App\Utils\ModelUtils;
use App\ViewModels\Setor\SetorRegistrationViewModel\SetorRegistrationViewModel;
use CodeIgniter\Model;

class SetorModel extends ModelEntity {
	protected $table = 'setor';
	protected $primaryKey = 'id';
	protected $returnType = 'array';
	protected $allowedFields = [ 
			'descricao',
			'id_centro_custo',
			'criado_em',
			'atualizado_em',
			'desativado_em',
			'criado_por',
			'alterado_por',
			'desativado_por'
	];
	protected $useSoftDeletes = false;
	protected $skipValidation = true;
	protected $useTimestamps = true;
	protected $createdField = 'criado_em';
	protected $updatedField = 'atualizado_em';

	public function registerSetor(Setor &$setor): void {

		$setor_data = $setor->toArray();
		unset( $setor_data ['id'] );
		unset( $setor_data ['criado_em'] );
		unset( $setor_data ['atualizado_em'] );
		$id_new_setor = $this->insert( $setor_data );
		$setor->setId( $id_new_setor );

	}

	public function updateSetorByID(int $id_setor, Setor $setor): bool {

		$data = $setor->toArray( true );
		if (count( $data ) > 0) {
			$binds = [ 
					'id_setor' => $id_setor
			];
			$sql = "UPDATE setor ";
			$sql .= $this->generateUpdateSets( $data, $binds );
			$sql .= 'WHERE setor.id = :id_setor:';
			$query = $this->db->query( $sql, $binds );
			$errors = $this->errors();
			return !$errors;
		} else {
			return true;
		}

	}

	public function deleteSetorByID(int $id_setor): bool {

		$jwt_payload = JWTService::getTokenJWTPayload();
		$uid = $jwt_payload ? $jwt_payload->getUid() : null;
		$today = DateUtils::today();

		$binds = [ 
				'desativado_por' => $uid,
				'desativado_em' => $today,
				'id_setor' => $id_setor
		];
		$sql = "UPDATE setor SET desativado_por = :desativado_por: , desativado_em = :desativado_em: WHERE setor.id = :id_setor:";
		$query = $this->db->query( $sql, $binds );

		$errors = $this->errors();
		return !$errors;

	}

}
